/* Tabela EXTRATOCONS: TABELA DE EXTRATO DO CONSUMIDOR */
/* Descrio: A trigger insere registros na tabela LOGOPERAVND a partir de alteraes na tabela EXTRATOCONS */
/* Objetivo: Gerar um log que vai registrar as alteraes na EXTRATOCONS,
             utilizando a tabela de Logs de Operaes do VND*/
CREATE OR REPLACE TRIGGER LOG_VND_EXTRATOCONS
AFTER DELETE OR INSERT OR UPDATE
ON EXTRATOCONS FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_ITPESQ       VARCHAR2(100);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_IDTIPOOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF UPDATING THEN
		IF NVL(:NEW.CDCLIENTE ,'NULL') <> NVL(:OLD.CDCLIENTE ,'NULL') THEN
			V_DESC := 'Cliente ' || '' || NVL(:NEW.CDCLIENTE,'');
		END IF;
		IF NVL(:NEW.CDCONSUMIDOR ,'NULL') <> NVL(:OLD.CDCONSUMIDOR ,'NULL') THEN
            V_DESC := NVL(V_DESC,'') || ' ' || 'Cd Cons ' || '' || NVL(:NEW.CDCONSUMIDOR,'');
		END IF;
		IF NVL(:NEW.CDFAMILISALD ,'NULL') <> NVL(:OLD.CDFAMILISALD ,'NULL') THEN
            V_DESC := NVL(V_DESC,'') || ' ' || 'CDFAMILISALD ' || '' || NVL(:NEW.CDFAMILISALD,'');
		END IF;
		IF NVL(:NEW.DTMOVEXTCONS ,TO_DATE('01/01/0001','DD/MM/YYYY')) <> NVL(:OLD.DTMOVEXTCONS ,TO_DATE('01/01/0001','DD/MM/YYYY')) THEN
            V_DESC := NVL(V_DESC,'') || ' ' || 'Dt Mov Ext ' || '' || NVL(:NEW.DTMOVEXTCONS,'');
		END IF;
		IF NVL(:NEW.NRSEQMOVEXT ,'NULL') <> NVL(:OLD.NRSEQMOVEXT ,'NULL') THEN
            V_DESC := NVL(V_DESC,'') || ' ' || 'NRSEQMOVEXT ' || '' || NVL(:NEW.NRSEQMOVEXT,'');
		END IF;
		IF NVL(:NEW.CDTIPORECE ,'NULL') <> NVL(:OLD.CDTIPORECE ,'NULL') THEN
            V_DESC := NVL(V_DESC,'') || ' ' || 'Tp Rece ' || '' || NVL(:NEW.CDTIPORECE,'');
		END IF;
		IF NVL(:NEW.CDFILIAL ,'NULL') <> NVL(:OLD.CDFILIAL ,'NULL') THEN
            V_DESC := NVL(V_DESC,'') || ' ' || 'Filial ' || '' || NVL(:NEW.CDFILIAL,'');
		END IF;
		IF NVL(:NEW.CDCAIXA ,'NULL') <> NVL(:OLD.CDCAIXA ,'NULL') THEN
            V_DESC := NVL(V_DESC,'') || ' ' || 'Caixa ' || '' || NVL(:NEW.CDCAIXA,'');
		END IF;
		IF NVL(:NEW.NRSEQVENDA ,'NULL') <> NVL(:OLD.NRSEQVENDA ,'NULL') THEN
            V_DESC := NVL(V_DESC,'') || ' ' || 'Nr Seq Venda ' || '' || NVL(:NEW.NRSEQVENDA,'');
		END IF;
		IF NVL(:NEW.DSOPEEXTCONS ,'NULL') <> NVL(:OLD.DSOPEEXTCONS ,'NULL') THEN
            V_DESC := NVL(V_DESC,'') || ' ' || 'DSOPEEXTCONS ' || '' || NVL(:NEW.DSOPEEXTCONS,'');
		END IF;
		IF NVL(:NEW.VRMOVEXTCONS ,999999) <> NVL(:OLD.VRMOVEXTCONS ,999999) THEN
            V_DESC := NVL(V_DESC,'') || ' ' || 'Vr Mov Ext ' || '' || NVL(:NEW.VRMOVEXTCONS,'');
		END IF;
		IF NVL(:NEW.VRSALDCONEXT ,999999) <> NVL(:OLD.VRSALDCONEXT ,999999) THEN
            V_DESC := NVL(V_DESC,'') || ' ' || 'Vr Saldo Cons ' || '' || NVL(:NEW.VRSALDCONEXT,'');
		END IF;
		IF NVL(:NEW.IDTPMOVEXT ,'NULL') <> NVL(:OLD.IDTPMOVEXT ,'NULL') THEN
            V_DESC := NVL(V_DESC,'') || ' ' || 'Tp Mov ' || '' || NVL(:NEW.IDTPMOVEXT,'');
		END IF;
		IF NVL(:NEW.IDIMPEXTCONS ,'NULL') <> NVL(:OLD.IDIMPEXTCONS ,'NULL') THEN
            V_DESC := NVL(V_DESC,'') || ' ' || 'Id Mov Exp ' || '' || NVL(:NEW.IDIMPEXTCONS,'');
		END IF;
		IF NVL(:NEW.NRDEPOSICONS ,'NULL') <> NVL(:OLD.NRDEPOSICONS ,'NULL') THEN
            V_DESC := NVL(V_DESC,'') || ' ' || 'NRDEPOSICONS ' || '' || NVL(:NEW.NRDEPOSICONS,'');
		END IF;
		IF NVL(:NEW.DTULTATUEXT ,TO_DATE('01/01/0001','DD/MM/YYYY')) <> NVL(:OLD.DTULTATUEXT ,TO_DATE('01/01/0001','DD/MM/YYYY')) THEN
            V_DESC := NVL(V_DESC,'') || ' ' || 'Dt Ult Atu ' || '' || NVL(:NEW.DTULTATUEXT,'');
		END IF;
		IF NVL(:NEW.DTABERCAIX ,TO_DATE('01/01/0001','DD/MM/YYYY')) <> NVL(:OLD.DTABERCAIX ,TO_DATE('01/01/0001','DD/MM/YYYY')) THEN
            V_DESC := NVL(V_DESC,'') || ' ' || 'Aber Caixa ' || '' || NVL(:NEW.DTABERCAIX,'');
		END IF;
		IF NVL(:NEW.IDCANZERASALD ,'NULL') <> NVL(:OLD.IDCANZERASALD ,'NULL') THEN
            V_DESC := NVL(V_DESC,'') || ' ' || 'IDCANZERASALD ' || '' || NVL(:NEW.IDCANZERASALD,'');
		END IF;
		IF NVL(:NEW.NRSEQMOVCAIXA ,'NULL') <> NVL(:OLD.NRSEQMOVCAIXA ,'NULL') THEN
            V_DESC := NVL(V_DESC,'') || ' ' || 'NRSEQMOVCAIXA ' || '' || NVL(:NEW.NRSEQMOVCAIXA,'');
		END IF;
		IF NVL(:NEW.NRSEQREGCREDVND ,'NULL') <> NVL(:OLD.NRSEQREGCREDVND ,'NULL') THEN
		   V_DESC := NVL(V_DESC,'') || ' ' || 'NRSEQREGCREDVND '   || '' || NVL(:NEW.NRSEQREGCREDVND,'' );
		END IF;
      V_ITPESQ := :NEW.CDCLIENTE||:NEW.CDCONSUMIDOR||:NEW.CDFAMILISALD||:NEW.DTMOVEXTCONS||:NEW.NRSEQMOVEXT;
      V_IDTIPOOPER := '2';
   ELSE
      IF INSERTING THEN
      V_DESC   := 'Cliente '           || '' || NVL(:NEW.CDCLIENTE,''       )   || ' ' ||
                  'Cd Cons '           || '' || NVL(:NEW.CDCONSUMIDOR,''    )   || ' ' ||
                  'CDFAMILISALD '      || '' || NVL(:NEW.CDFAMILISALD,''    )   || ' ' ||
                  'Dt Mov Ext '        || '' || NVL(:NEW.DTMOVEXTCONS,''    )   || ' ' ||
                  'NRSEQMOVEXT '       || '' || NVL(:NEW.NRSEQMOVEXT,''     )   || ' ' ||
                  'Tp Rece '           || '' || NVL(:NEW.CDTIPORECE,''      )   || ' ' ||
                  'Filial '            || '' || NVL(:NEW.CDFILIAL,''        )   || ' ' ||
                  'Caixa '             || '' || NVL(:NEW.CDCAIXA,''         )   || ' ' ||
                  'Nr Seq Venda '      || '' || NVL(:NEW.NRSEQVENDA,''      )   || ' ' ||
                  'DSOPEEXTCONS '      || '' || NVL(:NEW.DSOPEEXTCONS,''    )   || ' ' ||
                  'Vr Mov Ext '        || '' || NVL(:NEW.VRMOVEXTCONS,''    )   || ' ' ||
                  'Vr Saldo Cons '     || '' || NVL(:NEW.VRSALDCONEXT,''    )   || ' ' ||
                  'Tp Mov '            || '' || NVL(:NEW.IDTPMOVEXT,''      )   || ' ' ||
                  'Id Mov Exp '        || '' || NVL(:NEW.IDIMPEXTCONS,''    )   || ' ' ||
                  'NRDEPOSICONS '      || '' || NVL(:NEW.NRDEPOSICONS,''    )   || ' ' ||
                  'Dt Ult Atu '        || '' || NVL(:NEW.DTULTATUEXT,''     )   || ' ' ||
                  'Aber Caixa '        || '' || NVL(:NEW.DTABERCAIX,''      )   || ' ' ||
                  'IDCANZERASALD '     || '' || NVL(:NEW.IDCANZERASALD,''   )   || ' ' ||
                  'NRSEQMOVCAIXA '     || '' || NVL(:NEW.NRSEQMOVCAIXA,''   )   || ' ' ||
				  'NRSEQREGCREDVND '   || '' || NVL(:NEW.NRSEQREGCREDVND,'' );
      V_ITPESQ := :NEW.CDCLIENTE||:NEW.CDCONSUMIDOR||:NEW.CDFAMILISALD||:NEW.DTMOVEXTCONS||:NEW.NRSEQMOVEXT;
         V_IDTIPOOPER := '1';
      ELSE
         IF DELETING THEN
      V_DESC   := 'Cliente '           || '' || NVL(:OLD.CDCLIENTE,''       )   || ' ' ||
                  'Cd Cons '           || '' || NVL(:OLD.CDCONSUMIDOR,''    )   || ' ' ||
                  'CDFAMILISALD '      || '' || NVL(:OLD.CDFAMILISALD,''    )   || ' ' ||
                  'Dt Mov Ext '        || '' || NVL(:OLD.DTMOVEXTCONS,''    )   || ' ' ||
                  'NRSEQMOVEXT '       || '' || NVL(:OLD.NRSEQMOVEXT,''     )   || ' ' ||
                  'Tp Rece '           || '' || NVL(:OLD.CDTIPORECE,''      )   || ' ' ||
                  'Filial '            || '' || NVL(:OLD.CDFILIAL,''        )   || ' ' ||
                  'Caixa '             || '' || NVL(:OLD.CDCAIXA,''         )   || ' ' ||
                  'Nr Seq Venda '      || '' || NVL(:OLD.NRSEQVENDA,''      )   || ' ' ||
                  'DSOPEEXTCONS '      || '' || NVL(:OLD.DSOPEEXTCONS,''    )   || ' ' ||
                  'Vr Mov Ext '        || '' || NVL(:OLD.VRMOVEXTCONS,''    )   || ' ' ||
                  'Vr Saldo Cons '     || '' || NVL(:OLD.VRSALDCONEXT,''    )   || ' ' ||
                  'Tp Mov '            || '' || NVL(:OLD.IDTPMOVEXT,''      )   || ' ' ||
                  'Id Mov Exp '        || '' || NVL(:OLD.IDIMPEXTCONS,''    )   || ' ' ||
                  'NRDEPOSICONS '      || '' || NVL(:OLD.NRDEPOSICONS,''    )   || ' ' ||
                  'Dt Ult Atu '        || '' || NVL(:OLD.DTULTATUEXT,''     )   || ' ' ||
                  'Aber Caixa '        || '' || NVL(:OLD.DTABERCAIX,''      )   || ' ' ||
                  'IDCANZERASALD '     || '' || NVL(:OLD.IDCANZERASALD,''   )   || ' ' ||
                  'NRSEQMOVCAIXA '     || '' || NVL(:OLD.NRSEQMOVCAIXA,''   )   || ' ' ||
				  'NRSEQREGCREDVND '   || '' || NVL(:OLD.NRSEQREGCREDVND,'' );
      V_ITPESQ := :OLD.CDCLIENTE||:OLD.CDCONSUMIDOR||:OLD.CDFAMILISALD||:OLD.DTMOVEXTCONS||:OLD.NRSEQMOVEXT;
            V_IDTIPOOPER := '3';
         END IF;
      END IF;
   END IF;
   V_DESC := SUBSTR(V_DESC, 1, 300);
   INSERT INTO LOGOPERAVND
      (NMTABELAVND,
       DTOPERACAOVND,
       NMRESPOPERVND,
       IDTIPOOPERVND,
       DSOPERACAOVND,
       CDPESQITEMVND,
       DSRDMUSUOPERVND,
       DSENDUSUOPERVND,
       DSNMUSUOPERVND,
       DSMETUSUOPERVND,
       CDORESPOPERVND,
       CDFILLOGOPERVND)
   VALUES
      ('EXTRATOCONS',
       SYSDATE,
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       NVL(V_DESC,' '),
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER,
       NVL(:NEW.CDFILIAL,:OLD.CDFILIAL));
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_VND_EXTRATOCONS','5.20.001'); END;
/
