/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PROMOPRBASE                                              */
/* Tabela : PROMOPRBASE                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 29/07/2016 - Srgio Pow Gomes                                              */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PROMOPRBASE' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_PROMOPRBASE
GO

CREATE TRIGGER DTULTATU_PROMOPRBASE
ON PROMOPRBASE
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      UPDATE PRODWEBSYNC
      SET DTULTALTPROD = GETDATE(), IDATUALIZADO = 'N'
      FROM DELETED
      WHERE (PRODWEBSYNC.CDPRODUTO = DELETED.CDPRODUTO);
   END
   ELSE BEGIN            
      UPDATE PRODWEBSYNC
      SET DTULTALTPROD = GETDATE(), IDATUALIZADO = 'N'
      FROM INSERTED
      WHERE (ISNULL(PROMOPRBASE.DTINIVALIPB   ,CONVERT(DATETIME,'31/12/1899')) = ISNULL(INSERTED.DTINIVALIPB,CONVERT(DATETIME,'31/12/1899'))) AND
            (ISNULL(PROMOPRBASE.DTINIPROMO    ,CONVERT(DATETIME,'31/12/1899')) = ISNULL(INSERTED.DTINIPROMO ,CONVERT(DATETIME,'31/12/1899'))) AND
            (ISNULL(PROMOPRBASE.DTFINPROMO    ,CONVERT(DATETIME,'31/12/1899')) = ISNULL(INSERTED.DTFINPROMO ,CONVERT(DATETIME,'31/12/1899'))) AND
            (ISNULL(PROMOPRBASE.IDTIPOPROMO   ,0) = ISNULL(INSERTED.IDTIPOPROMO   ,0)) AND
            (ISNULL(PROMOPRBASE.IDDIASPROMO   ,0) = ISNULL(INSERTED.IDDIASPROMO   ,0)) AND
            (ISNULL(PROMOPRBASE.IDSTATUSPROMO ,0) = ISNULL(INSERTED.IDSTATUSPROMO ,0)) AND
            (ISNULL(PROMOPRBASE.VRPERBASEPROMO,0) = ISNULL(INSERTED.VRPERBASEPROMO,0)) AND
            (ISNULL(PROMOPRBASE.VRTOTALPROMO  ,0) = ISNULL(INSERTED.VRTOTALPROMO  ,0)) AND
            (PRODWEBSYNC.CDPRODUTO = INSERTED.CDPRODUTO);
   END;
END;
GO