/* Tabela CONSUMIDOR: TABELA DE CONSUMIDOR*/
/* Descrio: A trigger insere registros na tabela LOGOPERAVND a partir de alteraes na tabela CONSUMIDOR */
/* Objetivo: Gerar um log que vai registrar as alteraes na CONSUMIDOR,
             utilizando a tabela de Logs de Operaes do VND*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_VND_CONSUMIDOR' AND
                 TYPE   = 'TR' 	               AND
	              U.UID  = O.UID           AND
	              U.NAME = USER)
DROP TRIGGER LOG_VND_CONSUMIDOR
GO


CREATE TRIGGER LOG_VND_CONSUMIDOR
ON CONSUMIDOR
FOR INSERT, UPDATE, DELETE
AS
  DECLARE @V_DSREMOTEADDR VARCHAR(15);
  DECLARE @V_DSREMOTEHOST VARCHAR(15);
  DECLARE @V_DSSERVERRDM  VARCHAR(20);
  DECLARE @V_DSSERVMETHOD VARCHAR(30);
  DECLARE @V_DSREMOTEOPER VARCHAR(12);
  DECLARE @V_DESC         VARCHAR(500);
  DECLARE @V_ITPESQ       VARCHAR(40);
  DECLARE @V_NMOPERADOR   VARCHAR(40);
  DECLARE @V_IDTIPOOPER   VARCHAR(1);

/*VARIVEIS DO CURSOR C_CURSOR*/

  DECLARE @V_ID_COMANDO    VARCHAR(1);

  DECLARE @V_NEW_CDCLIENTE	    varchar(21);
  DECLARE @V_NEW_CDCONSUMIDOR	    varchar(21);
  DECLARE @V_NEW_NMCONSUMIDOR	    varchar(50);
  DECLARE @V_NEW_VRLIMDEBCONS	    decimal(17);
  DECLARE @V_NEW_IDSITCONSUMI	    varchar(1);
  DECLARE @V_NEW_CDPAIS		    varchar(4);
  DECLARE @V_NEW_SGESTADO	    varchar(2);
  DECLARE @V_NEW_CDMUNICIPIO	    varchar(4);
  DECLARE @V_NEW_CDTIPOCONS	    varchar(2);
  DECLARE @V_NEW_CDCCUSCLIE	    varchar(10);
  DECLARE @V_NEW_VRAVIDEBCONS	    decimal(17);
  DECLARE @V_NEW_CDIDCONSUMID	    varchar(21);
  DECLARE @V_NEW_CDEXCONSUMID	    varchar(21);
  DECLARE @V_NEW_DSENDECONS	    varchar(50);
  DECLARE @V_NEW_NMBAIRCONS	    varchar(30);
  DECLARE @V_NEW_NRCEPCONS	    varchar(15);
  DECLARE @V_NEW_NRTELECONS	    varchar(25);
  DECLARE @V_NEW_NRRAMAL1CONS	    varchar(4);
  DECLARE @V_NEW_NRTELE2CONS	    varchar(25);
  DECLARE @V_NEW_NRRAMAL2CONS	    varchar(4);
  DECLARE @V_NEW_NRFAXCONS	    varchar(25);
  DECLARE @V_NEW_DSEMAILCONS	    varchar(50);
  DECLARE @V_NEW_IDVERSALDCON	    varchar(1);
  DECLARE @V_NEW_VRMESUBCONS	    decimal(17);
  DECLARE @V_NEW_VRPESUBCONS	    decimal(17);
  DECLARE @V_NEW_CDREGRACONS	    varchar(10);
  DECLARE @V_NEW_QTACECATCONS	    float(8);
  DECLARE @V_NEW_DTULTMOVCONS	    datetime;
  DECLARE @V_NEW_NRCTACORCONS	    varchar(20);
  DECLARE @V_NEW_IDCONSUMIDOR	    varchar(1);
  DECLARE @V_NEW_CDVENDEDOR	    varchar(4);
  DECLARE @V_NEW_DTULTATUCSUM	    datetime;
  DECLARE @V_NEW_NRRGCONSUMID	    varchar(20);
  DECLARE @V_NEW_IDATUCONSUMI	    varchar(1);
  DECLARE @V_NEW_CDSENHACONS	    varchar(40);
  DECLARE @V_NEW_NRCPFRESPCON	    varchar(11);
  DECLARE @V_NEW_NMRESPCONS	    varchar(50);
  DECLARE @V_NEW_NMLOGINCONS	    varchar(30);
  DECLARE @V_NEW_DSINFOCONS	    varchar(200);
  DECLARE @V_NEW_IDSEXOCONS	    varchar(1);
  DECLARE @V_NEW_DTNASCCONS	    datetime;
  DECLARE @V_NEW_VRMAXDEBCONS	    decimal(17);
  DECLARE @V_NEW_VRLIMCREDCONS	    decimal(17);
  DECLARE @V_NEW_VRAVICREDCONS	    decimal(17);
  DECLARE @V_NEW_VRMAXCREDCONS	    decimal(17);
  DECLARE @V_NEW_CDSENHASITE	    varchar(40);
  DECLARE @V_NEW_VRDIASUBCONS	    decimal(17);
  DECLARE @V_NEW_NRACESSOSITE	    decimal(17);
  DECLARE @V_NEW_DSCOMPLENDECONS    varchar(100);
  DECLARE @V_NEW_NRCELULARCONS	    varchar(25);
  DECLARE @V_NEW_CDBAIRRO	    varchar(10);
  DECLARE @V_NEW_IDTPVENDACONS	    varchar(1);
  DECLARE @V_NEW_IDIMPCPFCUPOM	    varchar(1);
  DECLARE @V_NEW_IDCADCONFLIBCON    varchar(1);
  DECLARE @V_NEW_IDPERCONSPRODEX    varchar(1);
  DECLARE @V_NEW_NRENDECONS	    varchar(5);

  DECLARE @V_OLD_CDCLIENTE	    varchar(21);
  DECLARE @V_OLD_CDCONSUMIDOR	    varchar(21);
  DECLARE @V_OLD_NMCONSUMIDOR	    varchar(50);
  DECLARE @V_OLD_VRLIMDEBCONS	    decimal(17);
  DECLARE @V_OLD_IDSITCONSUMI	    varchar(1);
  DECLARE @V_OLD_CDPAIS		    varchar(4);
  DECLARE @V_OLD_SGESTADO	    varchar(2);
  DECLARE @V_OLD_CDMUNICIPIO	    varchar(4);
  DECLARE @V_OLD_CDTIPOCONS	    varchar(2);
  DECLARE @V_OLD_CDCCUSCLIE	    varchar(10);
  DECLARE @V_OLD_VRAVIDEBCONS	    decimal(17);
  DECLARE @V_OLD_CDIDCONSUMID	    varchar(21);
  DECLARE @V_OLD_CDEXCONSUMID	    varchar(21);
  DECLARE @V_OLD_DSENDECONS	    varchar(50);
  DECLARE @V_OLD_NMBAIRCONS	    varchar(30);
  DECLARE @V_OLD_NRCEPCONS	    varchar(15);
  DECLARE @V_OLD_NRTELECONS	    varchar(25);
  DECLARE @V_OLD_NRRAMAL1CONS	    varchar(4);
  DECLARE @V_OLD_NRTELE2CONS	    varchar(25);
  DECLARE @V_OLD_NRRAMAL2CONS	    varchar(4);
  DECLARE @V_OLD_NRFAXCONS	    varchar(25);
  DECLARE @V_OLD_DSEMAILCONS	    varchar(50);
  DECLARE @V_OLD_IDVERSALDCON	    varchar(1);
  DECLARE @V_OLD_VRMESUBCONS	    decimal(17);
  DECLARE @V_OLD_VRPESUBCONS	    decimal(17);
  DECLARE @V_OLD_CDREGRACONS	    varchar(10);
  DECLARE @V_OLD_QTACECATCONS	    float(8);
  DECLARE @V_OLD_DTULTMOVCONS	    datetime;
  DECLARE @V_OLD_NRCTACORCONS	    varchar(20);
  DECLARE @V_OLD_IDCONSUMIDOR	    varchar(1);
  DECLARE @V_OLD_CDVENDEDOR	    varchar(4);
  DECLARE @V_OLD_DTULTATUCSUM	    datetime;
  DECLARE @V_OLD_NRRGCONSUMID	    varchar(20);
  DECLARE @V_OLD_IDATUCONSUMI	    varchar(1);
  DECLARE @V_OLD_CDSENHACONS	    varchar(40);
  DECLARE @V_OLD_NRCPFRESPCON	    varchar(11);
  DECLARE @V_OLD_NMRESPCONS	    varchar(50);
  DECLARE @V_OLD_NMLOGINCONS	    varchar(30);
  DECLARE @V_OLD_DSINFOCONS	    varchar(200);
  DECLARE @V_OLD_IDSEXOCONS	    varchar(1);
  DECLARE @V_OLD_DTNASCCONS	    datetime;
  DECLARE @V_OLD_VRMAXDEBCONS	    decimal(17);
  DECLARE @V_OLD_VRLIMCREDCONS	    decimal(17);
  DECLARE @V_OLD_VRAVICREDCONS	    decimal(17);
  DECLARE @V_OLD_VRMAXCREDCONS	    decimal(17);
  DECLARE @V_OLD_CDSENHASITE	    varchar(40);
  DECLARE @V_OLD_VRDIASUBCONS	    decimal(17);
  DECLARE @V_OLD_NRACESSOSITE	    decimal(17);
  DECLARE @V_OLD_DSCOMPLENDECONS    varchar(100);
  DECLARE @V_OLD_NRCELULARCONS	    varchar(25);
  DECLARE @V_OLD_CDBAIRRO	    varchar(10);
  DECLARE @V_OLD_IDTPVENDACONS	    varchar(1);
  DECLARE @V_OLD_IDIMPCPFCUPOM	    varchar(1);
  DECLARE @V_OLD_IDCADCONFLIBCON    varchar(1);
  DECLARE @V_OLD_IDPERCONSPRODEX    varchar(1);
  DECLARE @V_OLD_NRENDECONS	    varchar(5);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   SET @V_DESC   = '';
   SET @V_ITPESQ     = '';
   SET @V_NMOPERADOR = '';
   SET @V_IDTIPOOPER = '';

   EXEC NMUSUARIO @P_NMUSUARIO = @V_NMOPERADOR OUTPUT;
   SET @V_NMOPERADOR = ISNULL(@V_NMOPERADOR, ' ');

   EXEC WEBTUNNING  @P_DSREMOTEADDR = @V_DSREMOTEADDR OUTPUT,
                    @P_DSREMOTEHOST = @V_DSREMOTEHOST OUTPUT,
                    @P_DSSERVERRDM  = @V_DSSERVERRDM OUTPUT,
                    @P_DSSERVMETHOD = @V_DSSERVMETHOD OUTPUT,
                    @P_DSREMOTEOPER = @V_DSREMOTEOPER OUTPUT;

   DECLARE C_CURSOR CURSOR FOR
     SELECT
     'D'   ID_COMANDO,
           NULL,NULL,NULL,NULL,NULL,NULL,
           NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
           NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
           NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
           NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
           NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
           DELETED.CDCLIENTE,
           DELETED.CDCONSUMIDOR,
           DELETED.NMCONSUMIDOR,
           DELETED.VRLIMDEBCONS,
           DELETED.IDSITCONSUMI,
           DELETED.CDPAIS,
           DELETED.SGESTADO,
           DELETED.CDMUNICIPIO,
           DELETED.CDTIPOCONS,
           DELETED.CDCCUSCLIE,
           DELETED.VRAVIDEBCONS,
           DELETED.CDIDCONSUMID,
           DELETED.CDEXCONSUMID,
           DELETED.DSENDECONS,
           DELETED.NMBAIRCONS,
           DELETED.NRCEPCONS,
           DELETED.NRTELECONS,
           DELETED.NRRAMAL1CONS,
           DELETED.NRTELE2CONS,
           DELETED.NRRAMAL2CONS,
           DELETED.NRFAXCONS,
           DELETED.DSEMAILCONS,
           DELETED.IDVERSALDCON,
           DELETED.VRMESUBCONS,
           DELETED.VRPESUBCONS,
           DELETED.CDREGRACONS,
           DELETED.QTACECATCONS,
           DELETED.DTULTMOVCONS,
           DELETED.NRCTACORCONS,
           DELETED.IDCONSUMIDOR,
           DELETED.CDVENDEDOR,
           DELETED.DTULTATUCSUM,
           DELETED.NRRGCONSUMID,
           DELETED.IDATUCONSUMI,
           DELETED.CDSENHACONS,
           DELETED.NRCPFRESPCON,
           DELETED.NMRESPCONS,
           DELETED.NMLOGINCONS,
           DELETED.DSINFOCONS,
           DELETED.IDSEXOCONS,
           DELETED.DTNASCCONS,
           DELETED.VRMAXDEBCONS,
           DELETED.VRLIMCREDCONS,
           DELETED.VRAVICREDCONS,
           DELETED.VRMAXCREDCONS,
           DELETED.CDSENHASITE,
           DELETED.VRDIASUBCONS,
           DELETED.NRACESSOSITE,
           DELETED.DSCOMPLENDECONS,
           DELETED.NRCELULARCONS,
           DELETED.CDBAIRRO,
           DELETED.IDTPVENDACONS,
           DELETED.IDIMPCPFCUPOM,
           DELETED.IDCADCONFLIBCON,
           DELETED.IDPERCONSPRODEX,
           DELETED.NRENDECONS

     FROM
           DELETED
     WHERE     
           DELETED.CDCLIENTE + DELETED.CDCONSUMIDOR  NOT IN (SELECT CDCLIENTE + CDCONSUMIDOR FROM INSERTED)
     UNION ALL

     SELECT
     'U'   IDCOMANDO,
           INSERTED.CDCLIENTE,
           INSERTED.CDCONSUMIDOR,
           INSERTED.NMCONSUMIDOR,
           INSERTED.VRLIMDEBCONS,
           INSERTED.IDSITCONSUMI,
           INSERTED.CDPAIS,
           INSERTED.SGESTADO,
           INSERTED.CDMUNICIPIO,
           INSERTED.CDTIPOCONS,
           INSERTED.CDCCUSCLIE,
           INSERTED.VRAVIDEBCONS,
           INSERTED.CDIDCONSUMID,
           INSERTED.CDEXCONSUMID,
           INSERTED.DSENDECONS,
           INSERTED.NMBAIRCONS,
           INSERTED.NRCEPCONS,
           INSERTED.NRTELECONS,
           INSERTED.NRRAMAL1CONS,
           INSERTED.NRTELE2CONS,
           INSERTED.NRRAMAL2CONS,
           INSERTED.NRFAXCONS,
           INSERTED.DSEMAILCONS,
           INSERTED.IDVERSALDCON,
           INSERTED.VRMESUBCONS,
           INSERTED.VRPESUBCONS,
           INSERTED.CDREGRACONS,
           INSERTED.QTACECATCONS,
           INSERTED.DTULTMOVCONS,
           INSERTED.NRCTACORCONS,
           INSERTED.IDCONSUMIDOR,
           INSERTED.CDVENDEDOR,
           INSERTED.DTULTATUCSUM,
           INSERTED.NRRGCONSUMID,
           INSERTED.IDATUCONSUMI,
           INSERTED.CDSENHACONS,
           INSERTED.NRCPFRESPCON,
           INSERTED.NMRESPCONS,
           INSERTED.NMLOGINCONS,
           INSERTED.DSINFOCONS,
           INSERTED.IDSEXOCONS,
           INSERTED.DTNASCCONS,
           INSERTED.VRMAXDEBCONS,
           INSERTED.VRLIMCREDCONS,
           INSERTED.VRAVICREDCONS,
           INSERTED.VRMAXCREDCONS,
           INSERTED.CDSENHASITE,
           INSERTED.VRDIASUBCONS,
           INSERTED.NRACESSOSITE,
           INSERTED.DSCOMPLENDECONS,
           INSERTED.NRCELULARCONS,
           INSERTED.CDBAIRRO,
           INSERTED.IDTPVENDACONS,
           INSERTED.IDIMPCPFCUPOM,
           INSERTED.IDCADCONFLIBCON,
           INSERTED.IDPERCONSPRODEX,
           INSERTED.NRENDECONS,
           DELETED.CDCLIENTE,
           DELETED.CDCONSUMIDOR,
           DELETED.NMCONSUMIDOR,
           DELETED.VRLIMDEBCONS,
           DELETED.IDSITCONSUMI,
           DELETED.CDPAIS,
           DELETED.SGESTADO,
           DELETED.CDMUNICIPIO,
           DELETED.CDTIPOCONS,
           DELETED.CDCCUSCLIE,
           DELETED.VRAVIDEBCONS,
           DELETED.CDIDCONSUMID,
           DELETED.CDEXCONSUMID,
           DELETED.DSENDECONS,
           DELETED.NMBAIRCONS,
           DELETED.NRCEPCONS,
           DELETED.NRTELECONS,
           DELETED.NRRAMAL1CONS,
           DELETED.NRTELE2CONS,
           DELETED.NRRAMAL2CONS,
           DELETED.NRFAXCONS,
           DELETED.DSEMAILCONS,
           DELETED.IDVERSALDCON,
           DELETED.VRMESUBCONS,
           DELETED.VRPESUBCONS,
           DELETED.CDREGRACONS,
           DELETED.QTACECATCONS,
           DELETED.DTULTMOVCONS,
           DELETED.NRCTACORCONS,
           DELETED.IDCONSUMIDOR,
           DELETED.CDVENDEDOR,
           DELETED.DTULTATUCSUM,
           DELETED.NRRGCONSUMID,
           DELETED.IDATUCONSUMI,
           DELETED.CDSENHACONS,
           DELETED.NRCPFRESPCON,
           DELETED.NMRESPCONS,
           DELETED.NMLOGINCONS,
           DELETED.DSINFOCONS,
           DELETED.IDSEXOCONS,
           DELETED.DTNASCCONS,
           DELETED.VRMAXDEBCONS,
           DELETED.VRLIMCREDCONS,
           DELETED.VRAVICREDCONS,
           DELETED.VRMAXCREDCONS,
           DELETED.CDSENHASITE,
           DELETED.VRDIASUBCONS,
           DELETED.NRACESSOSITE,
           DELETED.DSCOMPLENDECONS,
           DELETED.NRCELULARCONS,
           DELETED.CDBAIRRO,
           DELETED.IDTPVENDACONS,
           DELETED.IDIMPCPFCUPOM,
           DELETED.IDCADCONFLIBCON,
           DELETED.IDPERCONSPRODEX,
           DELETED.NRENDECONS
     FROM
           INSERTED,
           DELETED
     WHERE     
           DELETED.CDCLIENTE    = INSERTED.CDCLIENTE    AND 
           DELETED.CDCONSUMIDOR = INSERTED.CDCONSUMIDOR 
     UNION ALL

     SELECT
     'I'   IDCOMANDO,
           INSERTED.CDCLIENTE,
           INSERTED.CDCONSUMIDOR,
           INSERTED.NMCONSUMIDOR,
           INSERTED.VRLIMDEBCONS,
           INSERTED.IDSITCONSUMI,
           INSERTED.CDPAIS,
           INSERTED.SGESTADO,
           INSERTED.CDMUNICIPIO,
           INSERTED.CDTIPOCONS,
           INSERTED.CDCCUSCLIE,
           INSERTED.VRAVIDEBCONS,
           INSERTED.CDIDCONSUMID,
           INSERTED.CDEXCONSUMID,
           INSERTED.DSENDECONS,
           INSERTED.NMBAIRCONS,
           INSERTED.NRCEPCONS,
           INSERTED.NRTELECONS,
           INSERTED.NRRAMAL1CONS,
           INSERTED.NRTELE2CONS,
           INSERTED.NRRAMAL2CONS,
           INSERTED.NRFAXCONS,
           INSERTED.DSEMAILCONS,
           INSERTED.IDVERSALDCON,
           INSERTED.VRMESUBCONS,
           INSERTED.VRPESUBCONS,
           INSERTED.CDREGRACONS,
           INSERTED.QTACECATCONS,
           INSERTED.DTULTMOVCONS,
           INSERTED.NRCTACORCONS,
           INSERTED.IDCONSUMIDOR,
           INSERTED.CDVENDEDOR,
           INSERTED.DTULTATUCSUM,
           INSERTED.NRRGCONSUMID,
           INSERTED.IDATUCONSUMI,
           INSERTED.CDSENHACONS,
           INSERTED.NRCPFRESPCON,
           INSERTED.NMRESPCONS,
           INSERTED.NMLOGINCONS,
           INSERTED.DSINFOCONS,
           INSERTED.IDSEXOCONS,
           INSERTED.DTNASCCONS,
           INSERTED.VRMAXDEBCONS,
           INSERTED.VRLIMCREDCONS,
           INSERTED.VRAVICREDCONS,
           INSERTED.VRMAXCREDCONS,
           INSERTED.CDSENHASITE,
           INSERTED.VRDIASUBCONS,
           INSERTED.NRACESSOSITE,
           INSERTED.DSCOMPLENDECONS,
           INSERTED.NRCELULARCONS,
           INSERTED.CDBAIRRO,
           INSERTED.IDTPVENDACONS,
           INSERTED.IDIMPCPFCUPOM,
           INSERTED.IDCADCONFLIBCON,
           INSERTED.IDPERCONSPRODEX,
           INSERTED.NRENDECONS,
           NULL,NULL,NULL,NULL,NULL,NULL,
           NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
           NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
           NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
           NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
           NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL
     FROM
           INSERTED
     WHERE     
           INSERTED.CDCLIENTE + INSERTED.CDCONSUMIDOR  NOT IN (SELECT CDCLIENTE + CDCONSUMIDOR FROM DELETED)


     OPEN C_CURSOR;
     FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
				   @V_NEW_CDCLIENTE,@V_NEW_CDCONSUMIDOR,@V_NEW_NMCONSUMIDOR,@V_NEW_VRLIMDEBCONS,
				   @V_NEW_IDSITCONSUMI,@V_NEW_CDPAIS,@V_NEW_SGESTADO,@V_NEW_CDMUNICIPIO,
				   @V_NEW_CDTIPOCONS,@V_NEW_CDCCUSCLIE,@V_NEW_VRAVIDEBCONS,@V_NEW_CDIDCONSUMID,
				   @V_NEW_CDEXCONSUMID,@V_NEW_DSENDECONS,@V_NEW_NMBAIRCONS,@V_NEW_NRCEPCONS,
				   @V_NEW_NRTELECONS,@V_NEW_NRRAMAL1CONS,@V_NEW_NRTELE2CONS,@V_NEW_NRRAMAL2CONS,
				   @V_NEW_NRFAXCONS,@V_NEW_DSEMAILCONS,@V_NEW_IDVERSALDCON,@V_NEW_VRMESUBCONS,
				   @V_NEW_VRPESUBCONS,@V_NEW_CDREGRACONS,@V_NEW_QTACECATCONS,@V_NEW_DTULTMOVCONS,
				   @V_NEW_NRCTACORCONS,@V_NEW_IDCONSUMIDOR,@V_NEW_CDVENDEDOR,@V_NEW_DTULTATUCSUM,
				   @V_NEW_NRRGCONSUMID,@V_NEW_IDATUCONSUMI,@V_NEW_CDSENHACONS,@V_NEW_NRCPFRESPCON,
				   @V_NEW_NMRESPCONS,@V_NEW_NMLOGINCONS,@V_NEW_DSINFOCONS,@V_NEW_IDSEXOCONS,
				   @V_NEW_DTNASCCONS,@V_NEW_VRMAXDEBCONS,@V_NEW_VRLIMCREDCONS,@V_NEW_VRAVICREDCONS,
				   @V_NEW_VRMAXCREDCONS,@V_NEW_CDSENHASITE,@V_NEW_VRDIASUBCONS,@V_NEW_NRACESSOSITE,
				   @V_NEW_DSCOMPLENDECONS,@V_NEW_NRCELULARCONS,@V_NEW_CDBAIRRO,@V_NEW_IDTPVENDACONS,
				   @V_NEW_IDIMPCPFCUPOM,@V_NEW_IDCADCONFLIBCON,@V_NEW_IDPERCONSPRODEX,@V_NEW_NRENDECONS,

				   @V_OLD_CDCLIENTE,@V_OLD_CDCONSUMIDOR,@V_OLD_NMCONSUMIDOR,@V_OLD_VRLIMDEBCONS,
				   @V_OLD_IDSITCONSUMI,@V_OLD_CDPAIS,@V_OLD_SGESTADO,@V_OLD_CDMUNICIPIO,
				   @V_OLD_CDTIPOCONS,@V_OLD_CDCCUSCLIE,@V_OLD_VRAVIDEBCONS,@V_OLD_CDIDCONSUMID,
				   @V_OLD_CDEXCONSUMID,@V_OLD_DSENDECONS,@V_OLD_NMBAIRCONS,@V_OLD_NRCEPCONS,
				   @V_OLD_NRTELECONS,@V_OLD_NRRAMAL1CONS,@V_OLD_NRTELE2CONS,@V_OLD_NRRAMAL2CONS,
				   @V_OLD_NRFAXCONS,@V_OLD_DSEMAILCONS,@V_OLD_IDVERSALDCON,@V_OLD_VRMESUBCONS,
				   @V_OLD_VRPESUBCONS,@V_OLD_CDREGRACONS,@V_OLD_QTACECATCONS,@V_OLD_DTULTMOVCONS,
				   @V_OLD_NRCTACORCONS,@V_OLD_IDCONSUMIDOR,@V_OLD_CDVENDEDOR,@V_OLD_DTULTATUCSUM,
				   @V_OLD_NRRGCONSUMID,@V_OLD_IDATUCONSUMI,@V_OLD_CDSENHACONS,@V_OLD_NRCPFRESPCON,
				   @V_OLD_NMRESPCONS,@V_OLD_NMLOGINCONS,@V_OLD_DSINFOCONS,@V_OLD_IDSEXOCONS,
				   @V_OLD_DTNASCCONS,@V_OLD_VRMAXDEBCONS,@V_OLD_VRLIMCREDCONS,@V_OLD_VRAVICREDCONS,
				   @V_OLD_VRMAXCREDCONS,@V_OLD_CDSENHASITE,@V_OLD_VRDIASUBCONS,@V_OLD_NRACESSOSITE,
				   @V_OLD_DSCOMPLENDECONS,@V_OLD_NRCELULARCONS,@V_OLD_CDBAIRRO,@V_OLD_IDTPVENDACONS,
				   @V_OLD_IDIMPCPFCUPOM,@V_OLD_IDCADCONFLIBCON,@V_OLD_IDPERCONSPRODEX,@V_OLD_NRENDECONS

    WHILE (@@FETCH_STATUS = 0) BEGIN
     IF @V_ID_COMANDO= 'U' /*UPDATE*/ BEGIN
      IF ISNULL(@V_NEW_CDCLIENTE ,'NULL') <> ISNULL(@V_OLD_CDCLIENTE ,'NULL') BEGIN 
         SET @V_DESC = 'Cd Clie ' + ISNULL(@V_NEW_CDCLIENTE,'' );
      END;
      IF ISNULL(@V_NEW_CDCONSUMIDOR ,'NULL') <> ISNULL(@V_OLD_CDCONSUMIDOR ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Cons ' + ISNULL(@V_NEW_CDCONSUMIDOR,'' );
      END;
      IF ISNULL(@V_NEW_NMCONSUMIDOR ,'NULL') <> ISNULL(@V_OLD_NMCONSUMIDOR ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Nm Cons ' + ISNULL(@V_NEW_NMCONSUMIDOR,'' );
      END;
      IF ISNULL(CONVERT(VARCHAR,@V_NEW_VRLIMDEBCONS) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_VRLIMDEBCONS) ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Vr Lim Deb ' + ISNULL(CONVERT(VARCHAR,@V_NEW_VRLIMDEBCONS),'' );
      END;
      IF ISNULL(@V_NEW_IDSITCONSUMI ,'NULL') <> ISNULL(@V_OLD_IDSITCONSUMI ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Id Sit Cons ' + ISNULL(@V_NEW_IDSITCONSUMI,'' );
      END;
      IF ISNULL(@V_NEW_CDPAIS ,'NULL') <> ISNULL(@V_OLD_CDPAIS ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Pais ' + ISNULL(@V_NEW_CDPAIS,'' );
      END;
      IF ISNULL(@V_NEW_SGESTADO ,'NULL') <> ISNULL(@V_OLD_SGESTADO ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Sg Estado ' + ISNULL(@V_NEW_SGESTADO,'' );
      END;
      IF ISNULL(@V_NEW_CDMUNICIPIO ,'NULL') <> ISNULL(@V_OLD_CDMUNICIPIO ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Municipo ' + ISNULL(@V_NEW_CDMUNICIPIO,'' );
      END;
      IF ISNULL(@V_NEW_CDTIPOCONS ,'NULL') <> ISNULL(@V_OLD_CDTIPOCONS ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Tp Cons ' + ISNULL(@V_NEW_CDTIPOCONS,'' );
      END;
      IF ISNULL(@V_NEW_CDCCUSCLIE ,'NULL') <> ISNULL(@V_OLD_CDCCUSCLIE ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Custo Clie ' + ISNULL(@V_NEW_CDCCUSCLIE,'' );
      END;
      IF ISNULL(CONVERT(VARCHAR,@V_NEW_VRAVIDEBCONS) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_VRAVIDEBCONS) ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Vr Avi Deb' + ISNULL(CONVERT(VARCHAR,@V_NEW_VRAVIDEBCONS),'' );
      END;
      IF ISNULL(@V_NEW_CDIDCONSUMID ,'NULL') <> ISNULL(@V_OLD_CDIDCONSUMID ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Id Cons ' + ISNULL(@V_NEW_CDIDCONSUMID,'' );
      END;
      IF ISNULL(@V_NEW_CDEXCONSUMID ,'NULL') <> ISNULL(@V_OLD_CDEXCONSUMID ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Ex Cons ' + ISNULL(@V_NEW_CDEXCONSUMID,'' );
      END;
      IF ISNULL(@V_NEW_DSENDECONS ,'NULL') <> ISNULL(@V_OLD_DSENDECONS ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' End Cons ' + ISNULL(@V_NEW_DSENDECONS,'' );
      END;
      IF ISNULL(@V_NEW_NMBAIRCONS ,'NULL') <> ISNULL(@V_OLD_NMBAIRCONS ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Bairro ' + ISNULL(@V_NEW_NMBAIRCONS,'' );
      END;
      IF ISNULL(@V_NEW_NRCEPCONS ,'NULL') <> ISNULL(@V_OLD_NRCEPCONS ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cep' + ISNULL(@V_NEW_NRCEPCONS,'' );
      END;
      IF ISNULL(@V_NEW_NRTELECONS ,'NULL') <> ISNULL(@V_OLD_NRTELECONS ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Tel ' + ISNULL(@V_NEW_NRTELECONS,'' );
      END;
      IF ISNULL(@V_NEW_NRRAMAL1CONS ,'NULL') <> ISNULL(@V_OLD_NRRAMAL1CONS ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Ramal ' + ISNULL(@V_NEW_NRRAMAL1CONS,'' );
      END;
      IF ISNULL(@V_NEW_NRTELE2CONS ,'NULL') <> ISNULL(@V_OLD_NRTELE2CONS ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Tel2 ' + ISNULL(@V_NEW_NRTELE2CONS,'' );
      END;
      IF ISNULL(@V_NEW_NRRAMAL2CONS ,'NULL') <> ISNULL(@V_OLD_NRRAMAL2CONS ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Ramal2 ' + ISNULL(@V_NEW_NRRAMAL2CONS,'' );
      END;
      IF ISNULL(@V_NEW_NRFAXCONS ,'NULL') <> ISNULL(@V_OLD_NRFAXCONS ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Fax ' + ISNULL(@V_NEW_NRFAXCONS,'' );
      END;
      IF ISNULL(@V_NEW_DSEMAILCONS ,'NULL') <> ISNULL(@V_OLD_DSEMAILCONS ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Email ' + ISNULL(@V_NEW_DSEMAILCONS,'' );
      END;
      IF ISNULL(@V_NEW_IDVERSALDCON ,'NULL') <> ISNULL(@V_OLD_IDVERSALDCON ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Id Sald Neg ' + ISNULL(@V_NEW_IDVERSALDCON,'' );
      END;
      IF ISNULL(CONVERT(VARCHAR,@V_NEW_VRMESUBCONS) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_VRMESUBCONS) ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Vr Md Sub ' + ISNULL(CONVERT(VARCHAR,@V_NEW_VRMESUBCONS),'' );
      END;
      IF ISNULL(CONVERT(VARCHAR,@V_NEW_VRPESUBCONS) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_VRPESUBCONS) ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Vr Per Sub ' + ISNULL(CONVERT(VARCHAR,@V_NEW_VRPESUBCONS),'' );
      END;
      IF ISNULL(@V_NEW_CDREGRACONS ,'NULL') <> ISNULL(@V_OLD_CDREGRACONS ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Rg Consumo ' + ISNULL(@V_NEW_CDREGRACONS,'' );
      END;
      IF ISNULL(CONVERT(VARCHAR,@V_NEW_VRPESUBCONS) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_VRPESUBCONS) ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Qt Ace Cat ' + ISNULL(CONVERT(VARCHAR,@V_NEW_VRPESUBCONS),'' );
      END;
      IF ISNULL(CONVERT(VARCHAR,@V_NEW_DTULTMOVCONS) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_DTULTMOVCONS) ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Dt Ult Mov ' + ISNULL(CONVERT(VARCHAR,@V_NEW_DTULTMOVCONS),'' );
      END;
      IF ISNULL(@V_NEW_NRCTACORCONS ,'NULL') <> ISNULL(@V_OLD_NRCTACORCONS ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Nr Cta ' + ISNULL(@V_NEW_NRCTACORCONS,'' );
      END;
      IF ISNULL(@V_NEW_IDCONSUMIDOR ,'NULL') <> ISNULL(@V_OLD_IDCONSUMIDOR ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Id Cons ' + ISNULL(@V_NEW_IDCONSUMIDOR,'' );
      END;
      IF ISNULL(@V_NEW_CDVENDEDOR ,'NULL') <> ISNULL(@V_OLD_CDVENDEDOR ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Vendedor ' + ISNULL(@V_NEW_CDVENDEDOR,'' );
      END;
      IF ISNULL(CONVERT(VARCHAR,@V_NEW_DTULTATUCSUM) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_DTULTATUCSUM) ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Dt Ult Atu ' + ISNULL(CONVERT(VARCHAR,@V_NEW_DTULTATUCSUM),'' );
      END;
      IF ISNULL(@V_NEW_NRRGCONSUMID ,'NULL') <> ISNULL(@V_OLD_NRRGCONSUMID ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Rg ' + ISNULL(@V_NEW_NRRGCONSUMID,'' );
      END;
      IF ISNULL(@V_NEW_IDATUCONSUMI ,'NULL') <> ISNULL(@V_OLD_IDATUCONSUMI ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Id Atu ' + ISNULL(@V_NEW_IDATUCONSUMI,'' );
      END;
      IF ISNULL(@V_NEW_CDSENHACONS ,'NULL') <> ISNULL(@V_OLD_CDSENHACONS ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Senha ' + ISNULL(@V_NEW_CDSENHACONS,'' );
      END;
      IF ISNULL(@V_NEW_NRCPFRESPCON ,'NULL') <> ISNULL(@V_OLD_NRCPFRESPCON ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cpf Resp ' + ISNULL(@V_NEW_NRCPFRESPCON,'' );
      END;
      IF ISNULL(@V_NEW_NMRESPCONS ,'NULL') <> ISNULL(@V_OLD_NMRESPCONS ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Nr Resp ' + ISNULL(@V_NEW_NMRESPCONS,'' );
      END;
      IF ISNULL(@V_NEW_NMLOGINCONS ,'NULL') <> ISNULL(@V_OLD_NMLOGINCONS ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Login ' + ISNULL(@V_NEW_NMLOGINCONS,'' );
      END;
      IF ISNULL(@V_NEW_DSINFOCONS ,'NULL') <> ISNULL(@V_OLD_DSINFOCONS ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Info ' + ISNULL(@V_NEW_DSINFOCONS,'' );
      END;
      IF ISNULL(@V_NEW_IDSEXOCONS ,'NULL') <> ISNULL(@V_OLD_IDSEXOCONS ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Sexo ' + ISNULL(@V_NEW_IDSEXOCONS,'' );
      END;
      IF ISNULL(CONVERT(VARCHAR,@V_NEW_DTNASCCONS) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_DTNASCCONS) ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Dt Nasc ' + ISNULL(CONVERT(VARCHAR,@V_NEW_DTNASCCONS),'' );
      END;
      IF ISNULL(CONVERT(VARCHAR,@V_NEW_VRMAXDEBCONS) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_VRMAXDEBCONS) ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Vr Max Deb ' + ISNULL(CONVERT(VARCHAR,@V_NEW_VRMAXDEBCONS),'' );
      END;
      IF ISNULL(CONVERT(VARCHAR,@V_NEW_VRLIMCREDCONS) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_VRLIMCREDCONS) ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Vr Lim Cred ' + ISNULL(CONVERT(VARCHAR,@V_NEW_VRLIMCREDCONS),'' );
      END;
      IF ISNULL(CONVERT(VARCHAR,@V_NEW_VRAVICREDCONS) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_VRAVICREDCONS) ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Vr Avi Cred ' + ISNULL(CONVERT(VARCHAR,@V_NEW_VRAVICREDCONS),'' );
      END;
      IF ISNULL(CONVERT(VARCHAR,@V_NEW_VRMAXCREDCONS) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_VRMAXCREDCONS) ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Vr Max Cred ' + ISNULL(CONVERT(VARCHAR,@V_NEW_VRMAXCREDCONS),'' );
      END;
      IF ISNULL(@V_NEW_CDSENHASITE ,'NULL') <> ISNULL(@V_OLD_CDSENHASITE ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Senha Resp ' + ISNULL(@V_NEW_CDSENHASITE,'' );
      END;
      IF ISNULL(CONVERT(VARCHAR,@V_NEW_VRDIASUBCONS) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_VRDIASUBCONS) ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Vr Consumo Dia ' + ISNULL(CONVERT(VARCHAR,@V_NEW_VRDIASUBCONS),'' );
      END;
      IF ISNULL(CONVERT(VARCHAR,@V_NEW_NRACESSOSITE) ,'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_NRACESSOSITE) ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Nr Acesso Site ' + ISNULL(CONVERT(VARCHAR,@V_NEW_NRACESSOSITE),'' );
      END;
      IF ISNULL(@V_NEW_DSCOMPLENDECONS ,'NULL') <> ISNULL(@V_OLD_DSCOMPLENDECONS ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Ds Compl End Cons ' + ISNULL(@V_NEW_DSCOMPLENDECONS,'' );
      END;
      IF ISNULL(@V_NEW_NRCELULARCONS ,'NULL') <> ISNULL(@V_OLD_NRCELULARCONS ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cel Cons ' + ISNULL(@V_NEW_NRCELULARCONS,'' );
      END;
      IF ISNULL(@V_NEW_CDBAIRRO ,'NULL') <> ISNULL(@V_OLD_CDBAIRRO ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Bairro ' + ISNULL(@V_NEW_CDBAIRRO,'' );
      END;
      IF ISNULL(@V_NEW_IDTPVENDACONS ,'NULL') <> ISNULL(@V_OLD_IDTPVENDACONS ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Id Tp Venda ' + ISNULL(@V_NEW_IDTPVENDACONS,'' );
      END;
      IF ISNULL(@V_NEW_IDIMPCPFCUPOM ,'NULL') <> ISNULL(@V_OLD_IDIMPCPFCUPOM ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Imp Cpf Cupom ' + ISNULL(@V_NEW_IDIMPCPFCUPOM,'' );
      END;
      IF ISNULL(@V_NEW_IDCADCONFLIBCON ,'NULL') <> ISNULL(@V_OLD_IDCADCONFLIBCON ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cad Conf lib ' + ISNULL(@V_NEW_IDCADCONFLIBCON,'' );
      END;
      IF ISNULL(@V_NEW_IDPERCONSPRODEX ,'NULL') <> ISNULL(@V_OLD_IDPERCONSPRODEX ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Per Consumo Ex ' + ISNULL(@V_NEW_IDPERCONSPRODEX,'' );
      END;
      IF ISNULL(@V_NEW_NRENDECONS ,'NULL') <> ISNULL(@V_OLD_NRENDECONS ,'NULL') BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' End Cons ' + ISNULL(@V_NEW_NRENDECONS,'' );
      END;
          SET @V_IDTIPOOPER = '2';
       END;
       IF @V_ID_COMANDO= 'I' /*INSERO*/ BEGIN
      IF @V_NEW_CDCLIENTE IS NOT NULL BEGIN 
         SET @V_DESC = ' '  +  'Cd Clie'  +  ISNULL(@V_NEW_CDCLIENTE,'' );
      END;
      IF @V_NEW_CDCONSUMIDOR IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Cons ' + ISNULL(@V_NEW_CDCONSUMIDOR,'' );
      END;
      IF @V_NEW_NMCONSUMIDOR IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Nm Cons ' + ISNULL(@V_NEW_NMCONSUMIDOR,'' );
      END;
      IF @V_NEW_VRLIMDEBCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Vr Lim Deb ' + CONVERT(VARCHAR,@V_NEW_VRLIMDEBCONS);
      END;
      IF @V_NEW_IDSITCONSUMI IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Id Sit Cons ' + ISNULL(@V_NEW_IDSITCONSUMI,'' );
      END;
      IF @V_NEW_CDPAIS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Pais ' + ISNULL(@V_NEW_CDPAIS,'' );
      END;
      IF @V_NEW_SGESTADO IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Sg Estado ' + ISNULL(@V_NEW_SGESTADO,'' );
      END;
      IF @V_NEW_CDMUNICIPIO IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Municipo ' + ISNULL(@V_NEW_CDMUNICIPIO,'' );
      END;
      IF @V_NEW_CDTIPOCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Tp Cons ' + ISNULL(@V_NEW_CDTIPOCONS,'' );
      END;
      IF @V_NEW_CDCCUSCLIE IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Custo Clie ' + ISNULL(@V_NEW_CDCCUSCLIE,'' );
      END;
      IF @V_NEW_VRAVIDEBCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Vr Avi Deb ' + CONVERT(VARCHAR,@V_NEW_VRAVIDEBCONS);
      END;
      IF @V_NEW_CDIDCONSUMID IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Id Cons ' + ISNULL(@V_NEW_CDIDCONSUMID,'' );
      END;
      IF @V_NEW_CDEXCONSUMID IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Ex Cons ' + ISNULL(@V_NEW_CDEXCONSUMID,'' );
      END;
      IF @V_NEW_DSENDECONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' End Cons ' + ISNULL(@V_NEW_DSENDECONS,'' );
      END;
      IF @V_NEW_NMBAIRCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Bairro ' + ISNULL(@V_NEW_NMBAIRCONS,'' );
      END;
      IF @V_NEW_NRCEPCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cep ' + ISNULL(@V_NEW_NRCEPCONS,'' );
      END;
      IF @V_NEW_NRTELECONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Tel ' + ISNULL(@V_NEW_NRTELECONS,'' );
      END;
      IF @V_NEW_NRRAMAL1CONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Ramal ' + ISNULL(@V_NEW_NRRAMAL1CONS,'' );
      END;
      IF @V_NEW_NRTELE2CONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Tel2 ' + ISNULL(@V_NEW_NRTELE2CONS,'' );
      END;
      IF @V_NEW_NRRAMAL2CONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Ramal2 ' + ISNULL(@V_NEW_NRRAMAL2CONS,'' );
      END;
      IF @V_NEW_NRFAXCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Fax ' + ISNULL(@V_NEW_NRFAXCONS,'' );
      END;
      IF @V_NEW_DSEMAILCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Email ' + ISNULL(@V_NEW_DSEMAILCONS,'' );
      END;
      IF @V_NEW_IDVERSALDCON IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Id Sald Neg ' + ISNULL(@V_NEW_IDVERSALDCON,'' );
      END;
      IF @V_NEW_VRMESUBCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Vr Md Sub ' + CONVERT(VARCHAR,@V_NEW_VRMESUBCONS);
      END;
      IF @V_NEW_VRPESUBCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Vr Per Sub ' + CONVERT(VARCHAR,@V_NEW_VRPESUBCONS);
      END;
      IF @V_NEW_CDREGRACONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Rg Consumo ' + ISNULL(@V_NEW_CDREGRACONS,'' );
      END;
      IF @V_NEW_QTACECATCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Qt Ace Cat ' + CONVERT(VARCHAR,@V_NEW_VRPESUBCONS);
      END;
      IF @V_NEW_DTULTMOVCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Dt Ult Mov ' + ISNULL(CONVERT(VARCHAR,@V_NEW_DTULTMOVCONS),'' );
      END;
      IF @V_NEW_NRCTACORCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Nr Cta ' + ISNULL(@V_NEW_NRCTACORCONS,'' );
      END;
      IF @V_NEW_IDCONSUMIDOR IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Id Cons ' + ISNULL(@V_NEW_IDCONSUMIDOR,'' );
      END;
      IF @V_NEW_CDVENDEDOR IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Vendedor ' + ISNULL(@V_NEW_CDVENDEDOR,'' );
      END;
      IF @V_NEW_DTULTATUCSUM IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Dt Ult Atu ' + ISNULL(CONVERT(VARCHAR,@V_NEW_DTULTATUCSUM),'' );
      END;
      IF @V_NEW_NRRGCONSUMID IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Rg ' + ISNULL(@V_NEW_NRRGCONSUMID,'' );
      END;
      IF @V_NEW_IDATUCONSUMI IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Id Atu ' + ISNULL(@V_NEW_IDATUCONSUMI,'' );
      END;
      IF @V_NEW_CDSENHACONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Senha ' + ISNULL(@V_NEW_CDSENHACONS,'' );
      END;
      IF @V_NEW_NRCPFRESPCON IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cpf Resp ' + ISNULL(@V_NEW_NRCPFRESPCON,'' );
      END;
      IF @V_NEW_NMRESPCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Nr Resp ' + ISNULL(@V_NEW_NMRESPCONS,'' );
      END;
      IF @V_NEW_NMLOGINCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Login ' + ISNULL(@V_NEW_NMLOGINCONS,'' );
      END;
      IF @V_NEW_DSINFOCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Info ' + ISNULL(@V_NEW_DSINFOCONS,'' );
      END;
      IF @V_NEW_IDSEXOCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Sexo ' + ISNULL(@V_NEW_IDSEXOCONS,'' );
      END;
      IF @V_NEW_DTNASCCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Dt Nasc ' + ISNULL(CONVERT(VARCHAR,@V_NEW_DTNASCCONS),'' );
      END;
      IF @V_NEW_VRMAXDEBCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Vr Max Deb ' + ISNULL(CONVERT(VARCHAR,@V_NEW_VRMAXDEBCONS),'' );
      END;
      IF @V_NEW_VRLIMCREDCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Vr Lim Cred ' + ISNULL(CONVERT(VARCHAR,@V_NEW_VRLIMCREDCONS),'' );
      END;
      IF @V_NEW_VRAVICREDCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Vr Avi Cred ' + ISNULL(CONVERT(VARCHAR,@V_NEW_VRAVICREDCONS),'' );
      END;
      IF @V_NEW_VRMAXCREDCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Vr Max Cred ' + ISNULL(CONVERT(VARCHAR,@V_NEW_VRMAXCREDCONS),'' );
      END;
      IF @V_NEW_CDSENHASITE IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Senha Resp ' + ISNULL(@V_NEW_CDSENHASITE,'' );
      END;
      IF @V_NEW_VRDIASUBCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Vr Consumo Dia  ' + ISNULL(CONVERT(VARCHAR,@V_NEW_VRDIASUBCONS),'' );
      END;
      IF @V_NEW_NRACESSOSITE IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Nr Acesso Site ' + ISNULL(CONVERT(VARCHAR,@V_NEW_NRACESSOSITE),'' );
      END;
      IF @V_NEW_DSCOMPLENDECONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Ds Compl End Cons ' + ISNULL(@V_NEW_DSCOMPLENDECONS,'' );
      END;
      IF @V_NEW_NRCELULARCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cel Cons ' + ISNULL(@V_NEW_NRCELULARCONS,'' );
      END;
      IF @V_NEW_CDBAIRRO IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Bairro ' + ISNULL(@V_NEW_CDBAIRRO,'' );
      END;
      IF @V_NEW_IDTPVENDACONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Id Tp Venda ' + ISNULL(@V_NEW_IDTPVENDACONS,'' );
      END;
      IF @V_NEW_IDIMPCPFCUPOM IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Imp Cpf Cupom ' + ISNULL(@V_NEW_IDIMPCPFCUPOM,'' );
      END;
      IF @V_NEW_IDCADCONFLIBCON IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cad Conf lib ' + ISNULL(@V_NEW_IDCADCONFLIBCON,'' );
      END;
      IF @V_NEW_IDPERCONSPRODEX IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Per Consumo Ex ' + ISNULL(@V_NEW_IDPERCONSPRODEX,'' );
      END;
      IF @V_NEW_NRENDECONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' End Cons ' + ISNULL(@V_NEW_NRENDECONS,'' );
      END;
          SET @V_IDTIPOOPER = '1';
       END;
       IF @V_ID_COMANDO= 'D' /*DELEO*/  BEGIN
      IF @V_OLD_CDCLIENTE IS NOT NULL BEGIN 
         SET @V_DESC = ' '  +  'Cd Clie ' + ISNULL(@V_OLD_CDCLIENTE,'' );
      END;
      IF @V_OLD_CDCONSUMIDOR IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Cons ' + ISNULL(@V_OLD_CDCONSUMIDOR,'' );
      END;
      IF @V_OLD_NMCONSUMIDOR IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Nm Cons ' + ISNULL(@V_OLD_NMCONSUMIDOR,'' );
      END;
      IF @V_OLD_VRLIMDEBCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Vr Lim Deb ' + ISNULL(CONVERT(VARCHAR,@V_OLD_VRLIMDEBCONS),'' );
      END;
      IF @V_OLD_IDSITCONSUMI IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Id Sit Cons ' + ISNULL(@V_OLD_IDSITCONSUMI,'' );
      END;
      IF @V_OLD_CDPAIS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Pais ' + ISNULL(@V_OLD_CDPAIS,'' );
      END;
      IF @V_OLD_SGESTADO IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Sg Estado ' + ISNULL(@V_OLD_SGESTADO,'' );
      END;
      IF @V_OLD_CDMUNICIPIO IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Municipo ' + ISNULL(@V_OLD_CDMUNICIPIO,'' );
      END;
      IF @V_OLD_CDTIPOCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Tp Cons ' + ISNULL(@V_OLD_CDTIPOCONS,'' );
      END;
      IF @V_OLD_CDCCUSCLIE IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Custo Clie ' + ISNULL(@V_OLD_CDCCUSCLIE,'' );
      END;
      IF @V_OLD_VRAVIDEBCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Vr Avi Deb ' + CONVERT(VARCHAR,@V_OLD_VRAVIDEBCONS);
      END;
      IF @V_OLD_CDIDCONSUMID IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Id Cons ' + ISNULL(@V_OLD_CDIDCONSUMID,'' );
      END;
      IF @V_OLD_CDEXCONSUMID IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Ex Cons ' + ISNULL(@V_OLD_CDEXCONSUMID,'' );
      END;
      IF @V_OLD_DSENDECONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' End Cons ' + ISNULL(@V_OLD_DSENDECONS,'' );
      END;
      IF @V_OLD_NMBAIRCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Bairro ' + ISNULL(@V_OLD_NMBAIRCONS,'' );
      END;
      IF @V_OLD_NRCEPCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cep ' + ISNULL(@V_OLD_NRCEPCONS,'' );
      END;
      IF @V_OLD_NRTELECONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Tel ' + ISNULL(@V_OLD_NRTELECONS,'' );
      END;
      IF @V_OLD_NRRAMAL1CONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Ramal ' + ISNULL(@V_OLD_NRRAMAL1CONS,'' );
      END;
      IF @V_OLD_NRTELE2CONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Tel2 ' + ISNULL(@V_OLD_NRTELE2CONS,'' );
      END;
      IF @V_OLD_NRRAMAL2CONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Ramal2 ' + ISNULL(@V_OLD_NRRAMAL2CONS,'' );
      END;
      IF @V_OLD_NRFAXCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Fax ' + ISNULL(@V_OLD_NRFAXCONS,'' );
      END;
      IF @V_OLD_DSEMAILCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Email ' + ISNULL(@V_OLD_DSEMAILCONS,'' );
      END;
      IF @V_OLD_IDVERSALDCON IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Id Sald Neg ' + ISNULL(@V_OLD_IDVERSALDCON,'' );
      END;
      IF @V_OLD_VRMESUBCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Vr Md Sub ' + ISNULL(CONVERT(VARCHAR,@V_OLD_VRMESUBCONS),'' );
      END;
      IF @V_OLD_VRPESUBCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Vr Per Sub ' + ISNULL(CONVERT(VARCHAR,@V_OLD_VRPESUBCONS),'' );
      END;
      IF @V_OLD_CDREGRACONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Rg Consumo ' + ISNULL(@V_OLD_CDREGRACONS,'' );
      END;
      IF @V_OLD_QTACECATCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Qt Ace Cat ' + ISNULL(CONVERT(VARCHAR,@V_OLD_VRPESUBCONS),'' );
      END;
      IF @V_OLD_DTULTMOVCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Dt Ult Mov ' + ISNULL(CONVERT(VARCHAR,@V_OLD_DTULTMOVCONS),'' );
      END;
      IF @V_OLD_NRCTACORCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Nr Cta ' + ISNULL(@V_OLD_NRCTACORCONS,'' );
      END;
      IF @V_OLD_IDCONSUMIDOR IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Id Cons ' + ISNULL(@V_OLD_IDCONSUMIDOR,'' );
      END;
      IF @V_OLD_CDVENDEDOR IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Vendedor ' + ISNULL(@V_OLD_CDVENDEDOR,'' );
      END;
      IF @V_OLD_DTULTATUCSUM IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Dt Ult Atu ' + ISNULL(CONVERT(VARCHAR,@V_OLD_DTULTATUCSUM),'' );
      END;
      IF @V_OLD_NRRGCONSUMID IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Rg ' + ISNULL(@V_OLD_NRRGCONSUMID,'' );
      END;
      IF @V_OLD_IDATUCONSUMI IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Id Atu ' + ISNULL(@V_OLD_IDATUCONSUMI,'' );
      END;
      IF @V_OLD_CDSENHACONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Senha ' + ISNULL(@V_OLD_CDSENHACONS,'' );
      END;
      IF @V_OLD_NRCPFRESPCON IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cpf Resp ' + ISNULL(@V_OLD_NRCPFRESPCON,'' );
      END;
      IF @V_OLD_NMRESPCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Nr Resp ' + ISNULL(@V_OLD_NMRESPCONS,'' );
      END;
      IF @V_OLD_NMLOGINCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Login ' + ISNULL(@V_OLD_NMLOGINCONS,'' );
      END;
      IF @V_OLD_DSINFOCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Info ' + ISNULL(@V_OLD_DSINFOCONS,'' );
      END;
      IF @V_OLD_IDSEXOCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Sexo ' + ISNULL(@V_OLD_IDSEXOCONS,'' );
      END;
      IF @V_OLD_DTNASCCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Dt Nasc ' + ISNULL(CONVERT(VARCHAR,@V_OLD_DTNASCCONS),'' );
      END;
      IF @V_OLD_VRMAXDEBCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Vr Max Deb ' + ISNULL(CONVERT(VARCHAR,@V_OLD_VRMAXDEBCONS),'' );
      END;
      IF @V_OLD_VRLIMCREDCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Vr Lim Cred ' + ISNULL(CONVERT(VARCHAR,@V_OLD_VRLIMCREDCONS),'' );
      END;
      IF @V_OLD_VRAVICREDCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Vr Avi Cred ' + ISNULL(CONVERT(VARCHAR,@V_OLD_VRAVICREDCONS),'' );
      END;
      IF @V_OLD_VRMAXCREDCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Vr Max Cred ' + ISNULL(CONVERT(VARCHAR,@V_OLD_VRMAXCREDCONS),'' );
      END;
      IF @V_OLD_CDSENHASITE IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Senha Resp ' + ISNULL(@V_OLD_CDSENHASITE,'' );
      END;
      IF @V_OLD_VRDIASUBCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Vr Consumo Dia  ' + ISNULL(CONVERT(VARCHAR,@V_OLD_VRDIASUBCONS),'' );
      END;
      IF @V_OLD_NRACESSOSITE IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Nr Acesso Site ' + ISNULL(CONVERT(VARCHAR,@V_OLD_NRACESSOSITE),'' );
      END;
      IF @V_OLD_DSCOMPLENDECONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Ds Compl End Cons ' + ISNULL(@V_OLD_DSCOMPLENDECONS,'' );
      END;
      IF @V_OLD_NRCELULARCONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cel Cons ' + ISNULL(@V_OLD_NRCELULARCONS,'' );
      END;
      IF @V_OLD_CDBAIRRO IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cd Bairro ' + ISNULL(@V_OLD_CDBAIRRO,'' );
      END;
      IF @V_OLD_IDTPVENDACONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Id Tp Venda ' + ISNULL(@V_OLD_IDTPVENDACONS,'' );
      END;
      IF @V_OLD_IDIMPCPFCUPOM IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Imp Cpf Cupom ' + ISNULL(@V_OLD_IDIMPCPFCUPOM,'' );
      END;
      IF @V_OLD_IDCADCONFLIBCON IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Cad Conf lib ' + ISNULL(@V_OLD_IDCADCONFLIBCON,'' );
      END;
      IF @V_OLD_IDPERCONSPRODEX IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' Per Consumo Ex ' + ISNULL(@V_OLD_IDPERCONSPRODEX,'' );
      END;
      IF @V_OLD_NRENDECONS IS NOT NULL BEGIN
         SET @V_DESC = ISNULL(@V_DESC, '') + ' End Cons ' + ISNULL(@V_OLD_NRENDECONS,'' );
      END;
          SET @V_IDTIPOOPER = '3';
       END;
       IF  (@V_IDTIPOOPER <> '') BEGIN
          IF @V_DESC IS NOT NULL BEGIN
             SET @V_ITPESQ =  ISNULL( @V_NEW_CDCLIENTE + @V_NEW_CDCONSUMIDOR , @V_OLD_CDCLIENTE + @V_OLD_CDCONSUMIDOR );
             SET @V_DESC = SUBSTRING(@V_DESC, 1, 300);
             INSERT INTO LOGOPERAVND
                    (NMTABELAVND, DTOPERACAOVND, NMRESPOPERVND, IDTIPOOPERVND, DSOPERACAOVND,
                     CDPESQITEMVND, DSRDMUSUOPERVND, DSENDUSUOPERVND, DSNMUSUOPERVND, DSMETUSUOPERVND,
                     CDORESPOPERVND)
             VALUES ('CONSUMIDOR',GETDATE(), ISNULL(@V_NMOPERADOR,' '), @V_IDTIPOOPER, @V_DESC, @V_ITPESQ,
                     @V_DSSERVERRDM, @V_DSREMOTEADDR, @V_DSREMOTEHOST, @V_DSSERVMETHOD, @V_DSREMOTEOPER);
          END;
       END;
       FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
				     @V_NEW_CDCLIENTE,@V_NEW_CDCONSUMIDOR,@V_NEW_NMCONSUMIDOR,@V_NEW_VRLIMDEBCONS,
				     @V_NEW_IDSITCONSUMI,@V_NEW_CDPAIS,@V_NEW_SGESTADO,@V_NEW_CDMUNICIPIO,
				     @V_NEW_CDTIPOCONS,@V_NEW_CDCCUSCLIE,@V_NEW_VRAVIDEBCONS,@V_NEW_CDIDCONSUMID,
				     @V_NEW_CDEXCONSUMID,@V_NEW_DSENDECONS,@V_NEW_NMBAIRCONS,@V_NEW_NRCEPCONS,
				     @V_NEW_NRTELECONS,@V_NEW_NRRAMAL1CONS,@V_NEW_NRTELE2CONS,@V_NEW_NRRAMAL2CONS,
				     @V_NEW_NRFAXCONS,@V_NEW_DSEMAILCONS,@V_NEW_IDVERSALDCON,@V_NEW_VRMESUBCONS,
				     @V_NEW_VRPESUBCONS,@V_NEW_CDREGRACONS,@V_NEW_QTACECATCONS,@V_NEW_DTULTMOVCONS,
				     @V_NEW_NRCTACORCONS,@V_NEW_IDCONSUMIDOR,@V_NEW_CDVENDEDOR,@V_NEW_DTULTATUCSUM,
				     @V_NEW_NRRGCONSUMID,@V_NEW_IDATUCONSUMI,@V_NEW_CDSENHACONS,@V_NEW_NRCPFRESPCON,
				     @V_NEW_NMRESPCONS,@V_NEW_NMLOGINCONS,@V_NEW_DSINFOCONS,@V_NEW_IDSEXOCONS,
				     @V_NEW_DTNASCCONS,@V_NEW_VRMAXDEBCONS,@V_NEW_VRLIMCREDCONS,@V_NEW_VRAVICREDCONS,
				     @V_NEW_VRMAXCREDCONS,@V_NEW_CDSENHASITE,@V_NEW_VRDIASUBCONS,@V_NEW_NRACESSOSITE,
				     @V_NEW_DSCOMPLENDECONS,@V_NEW_NRCELULARCONS,@V_NEW_CDBAIRRO,@V_NEW_IDTPVENDACONS,
				     @V_NEW_IDIMPCPFCUPOM,@V_NEW_IDCADCONFLIBCON,@V_NEW_IDPERCONSPRODEX,@V_NEW_NRENDECONS,

				     @V_OLD_CDCLIENTE,@V_OLD_CDCONSUMIDOR,@V_OLD_NMCONSUMIDOR,@V_OLD_VRLIMDEBCONS,
				     @V_OLD_IDSITCONSUMI,@V_OLD_CDPAIS,@V_OLD_SGESTADO,@V_OLD_CDMUNICIPIO,
				     @V_OLD_CDTIPOCONS,@V_OLD_CDCCUSCLIE,@V_OLD_VRAVIDEBCONS,@V_OLD_CDIDCONSUMID,
				     @V_OLD_CDEXCONSUMID,@V_OLD_DSENDECONS,@V_OLD_NMBAIRCONS,@V_OLD_NRCEPCONS,
				     @V_OLD_NRTELECONS,@V_OLD_NRRAMAL1CONS,@V_OLD_NRTELE2CONS,@V_OLD_NRRAMAL2CONS,
				     @V_OLD_NRFAXCONS,@V_OLD_DSEMAILCONS,@V_OLD_IDVERSALDCON,@V_OLD_VRMESUBCONS,
				     @V_OLD_VRPESUBCONS,@V_OLD_CDREGRACONS,@V_OLD_QTACECATCONS,@V_OLD_DTULTMOVCONS,
				     @V_OLD_NRCTACORCONS,@V_OLD_IDCONSUMIDOR,@V_OLD_CDVENDEDOR,@V_OLD_DTULTATUCSUM,
				     @V_OLD_NRRGCONSUMID,@V_OLD_IDATUCONSUMI,@V_OLD_CDSENHACONS,@V_OLD_NRCPFRESPCON,
				     @V_OLD_NMRESPCONS,@V_OLD_NMLOGINCONS,@V_OLD_DSINFOCONS,@V_OLD_IDSEXOCONS,
				     @V_OLD_DTNASCCONS,@V_OLD_VRMAXDEBCONS,@V_OLD_VRLIMCREDCONS,@V_OLD_VRAVICREDCONS,
				     @V_OLD_VRMAXCREDCONS,@V_OLD_CDSENHASITE,@V_OLD_VRDIASUBCONS,@V_OLD_NRACESSOSITE,
				     @V_OLD_DSCOMPLENDECONS,@V_OLD_NRCELULARCONS,@V_OLD_CDBAIRRO,@V_OLD_IDTPVENDACONS,
				     @V_OLD_IDIMPCPFCUPOM,@V_OLD_IDCADCONFLIBCON,@V_OLD_IDPERCONSPRODEX,@V_OLD_NRENDECONS
    SET @V_DESC   = '';
    END;
    CLOSE      C_CURSOR;
    DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_VND_CONSUMIDOR','5.20.001';
GO 